function [II, ellBinary, r_max_min_emboss]=generateEllipse(c1,c2,r1,r2,theta,s_factor_A,size_z_1,size_z_2,len1,len2,positive_fraction)

r1=abs(r1);
r2=abs(r2);
if min(r1,r2)<s_factor_A*9;
    r1=max(s_factor_A*9,r1);   %% the minimum used to be set to 0.2
    r2=max(s_factor_A*9,r2);
    disp('warning!!! the elliptical profile is collapsing onto itself!!');
end
s_factor_A=abs(s_factor_A);

if ~exist('s_factor_A','var');
    s_factor_A=0.01;
end

if ~exist('s_factor_B_to_A','var')
    s_factor_B_to_A=3;
end
s_factor_B=s_factor_A*s_factor_B_to_A;


s_factor=1;
s_factor=min(s_factor,min(r1,r2)/s_factor_B);

s_factor_A=s_factor_A*s_factor;
s_factor_B=s_factor_B*s_factor;


d2=1/(size_z_2-1)*len2;
d1=1/(size_z_1-1)*len1;

grid2eD=(0:size_z_2+1)*((len2+d2+d2)/(size_z_2+1))-d2-c2;
grid2eD=grid2eD(ones(size_z_1+2,1),:);
grid1eD=(0:size_z_1+1)*((len1+d1+d1)/(size_z_1+1))-d1-c1;
grid1eD=grid1eD';
grid1eD=grid1eD(:,ones(1,size_z_2+2));

grid1erR=(grid2eD*sin(theta)+grid1eD*cos(theta))/r1;
grid2erR=(grid2eD*cos(theta)-grid1eD*sin(theta))/r2;
re=sqrt(grid1erR.*grid1erR+grid2erR.*grid2erR);

d2=(re(2:end-1,3:end)-re(2:end-1,1:end-2))*(1/2/len2*size_z_2);
d1=(re(3:end,2:end-1)-re(1:end-2,2:end-1))*(1/2/len1*size_z_1);


r=re(2:end-1,2:end-1);

s2=d1.*d1+d2.*d2;
II=r-1;
II=-II.*II./s2;

II=(1/sqrt(2*pi)*(len1*len2/size_z_1/size_z_2))*(exp(II*(1/s_factor_A/s_factor_A/2))/s_factor_A-exp(II*(1/s_factor_B/s_factor_B/2))/s_factor_B)./r;

if nargout>2
    if ~exist('positive_fraction','var')
        positive_fraction=70/100;
    end
    r_emboss=max(r(II(:)>=max(II(:))*(1-positive_fraction)));
    ellBinary=(r<=1)|(II>=max(II(:))*(1-positive_fraction));
    
    r_min_emboss=min(r1,r2)*r_emboss;
    r_max_emboss=max(r1,r2)+(r_min_emboss-min(r1,r2));%*max(r1,r2)/min(r1,r2);
    r_max_min_emboss=[r_max_emboss,r_min_emboss];
end
